/*******************************************************************************
 * Copyright (c) 2010- Association for Decentralized Information Management in
 * Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.tests;

import org.simantics.databoard.accessor.reference.AccessorReference;
import org.simantics.databoard.accessor.reference.FieldNameReference;
import org.simantics.databoard.accessor.reference.KeyReference;
import org.simantics.databoard.accessor.reference.LabelReference;
import org.simantics.databoard.accessor.reference.OptionalValueReference;
import org.simantics.databoard.accessor.reference.VariantValueReference;
import org.simantics.databoard.binding.mutable.Variant;
import org.simantics.databoard.util.URIUtil;

public class Jotakin3 {

	public static void main(String[] args) {
		
		AccessorReference ref1 = AccessorReference.compile(
				new FieldNameReference("nodes"),
				new KeyReference( Variant.ofInstance("SINE") ),
				new FieldNameReference("value"),
				new OptionalValueReference(),
				new VariantValueReference()
				); 

		AccessorReference ref4 = AccessorReference.compile(
				new LabelReference("nodes"),
				new LabelReference("SSINE"),
				new LabelReference("value"),
				new LabelReference("o"),
				new LabelReference("v")
				); 
		
		System.out.println(ref1.toPath(true));	
		System.out.println(ref1.toPath(false));	
		
		AccessorReference ref2 = AccessorReference.parseString("n-nodes/m-SSINE/n-value/o/v");
		System.out.println(ref2.toPath(true));	
		System.out.println(ref2.toPath(false));	
		
		AccessorReference ref3 = AccessorReference.parseString("nodes/SSINE/value/o/v");
		System.out.println(ref3.toPath(true));	
		System.out.println(ref3.toPath(false));
		
		System.out.println( ref1.equals( ref2 ) );
		System.out.println( ref2.equals( ref1 ) );
		
		System.out.println( ref1.equals( ref3 ) );
		System.out.println( ref3.equals( ref1 ) );

		System.out.println( ref3.equals( ref4 ) );
		System.out.println( ref4.equals( ref3 ) );

	}
	
}

