/*******************************************************************************
 * Copyright (c) 2010- Association for Decentralized Information Management in
 * Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.tests;

import static org.junit.Assert.assertEquals;

import java.net.InetAddress;

import org.simantics.databoard.Accessors;
import org.simantics.databoard.accessor.Accessor;
import org.simantics.databoard.accessor.ByteAccessor;
import org.simantics.databoard.accessor.wire.WireClient;
import org.simantics.databoard.accessor.wire.WireServer;
import org.simantics.databoard.binding.mutable.MutableByte;
import org.simantics.databoard.binding.mutable.MutableByteBinding;
import org.simantics.databoard.method.Client;
import org.simantics.databoard.method.Server;

public class Jotakin4 {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		
		MutableByte b = new MutableByte();
		Accessor a = Accessors.getAccessor(MutableByteBinding.INSTANCE, b);
		WireServer wireServer = new WireServer(a);
		Server server = new Server(0, wireServer.getMethodInterface());
		WireClient wireClient = new WireClient();
		Client client = new Client(InetAddress.getByName("localhost"), server.getPort(), wireClient.getClientMethodInterface());
		wireClient.setServerMethodInterface(client.getConnection().getRemoteMethodInterface());
		ByteAccessor ba = (ByteAccessor) wireClient.getAccessor(null);
		b.value = 5;
		
		assertEquals(b.value, ba.getValue());		
		System.out.println( ba.getValue() );
		
		ba.setValue( (byte)10 );
		assertEquals(b.value, ba.getValue());		
		System.out.println(b.byteValue());		
		
	}

}

